#include "atmega2561.h"

void delay(uint32_t twait)
{
	while (twait--)
	asm volatile ("nop");
}

#if defined(interfaceI2C)
	void WriteCommand(unsigned char command)
	{
		Send_start();			//send start strings
		Send_byte(0x7A);		//Slave address
		Send_byte(0x00);		//Control Byte - Command
		Send_byte(command);		//payload
		Send_stop();
	}

	void WriteData(unsigned char data)
	{
		Send_start();			//send start strings
		Send_byte(0x7A);		//Slave address
		Send_byte(0x40);		//Control Byte - Data (non-continued)
		Send_byte(data);		//payload
		Send_stop();
	}
#elif defined(interface4WSPI)
	void WriteCommand(unsigned char command)
	{

		CLR_CS;   // chip selected
		CLR_CD;   // command mode

		SPI_WriteByte(command);	// set up data on bus

		SET_CS;   // deselect chip
	}

	void WriteData(unsigned char data)
	{
		CLR_CS;       // chip selected
		SET_CD;       // data mode

		SPI_WriteByte(data);	// set up data on bus

		SET_CS;       // deselect chip
	}
#endif //interface4WSPI

void reset_display(void)
{
	CLR_RESET;
	delay(10000);
	SET_RESET;
	delay(10000);
}
