#ifndef __ATMEGA2561_H__
#define __ATMEGA2561_H__

#include <util/delay.h>
#include "MMC_SD.h"
#include "TWI_driver.h"
#include "cfal12832d.h"
#include "readkeys.h"

#define LED_1     PD1
#define LED_2     PD2

#define LED1_OFF PORTD &= ~(1 << LED_1);
#define LED1_ON  PORTD |=  (1 << LED_1);
#define LED2_OFF PORTD &= ~(1 << LED_2);
#define LED2_ON  PORTD |=  (1 << LED_2);

// all on PORTC
#define	LCD_CD	PC7
#define	LCD_RW  PC6	// WR in 8080 mode
#define	LCD_E	PC5	// RD in 8080 mode
#define	LCD_WR  PC6	// WR in 8080 mode
#define	LCD_RD  PC5	// RD in 8080 mode
#define	LCD_CS	PC3
#define	LCD_RES	PC2

#define CLR_CD PORTC &= ~(1<<LCD_CD);
#define SET_CD PORTC |=  (1<<LCD_CD);

#define CLR_CS PORTC &= ~(1<<LCD_CS);
#define SET_CS PORTC |=  (1<<LCD_CS);

#define CLR_RESET PORTC &= ~(1<<LCD_RES);
#define SET_RESET PORTC |=  (1<<LCD_RES);

// 6800 mode pin functions
#define CLR_RW PORTC &= ~(1 << LCD_RW);   // 6800 mode
#define SET_RW PORTC |=  (1 << LCD_RW);   // 6800 mode
#define CLR_E  PORTC &= ~(1 << LCD_E);    // 6800 mode
#define SET_E  PORTC |=  (1 << LCD_E);    // 6800 mode

// 8080 mode pin functions
#define CLR_WR PORTC &= ~(1 << LCD_WR);   // 8080 mode
#define SET_WR PORTC |=  (1 << LCD_WR);   // 8080 mode
#define CLR_RD PORTC &= ~(1 << LCD_RD);   // 8080 mode
#define SET_RD PORTC |=  (1 << LCD_RD);   // 8080 mode

#if defined(interface3WSPI)
#define WriteCommand(cmd)	soft_spi_send_byte(0, cmd)
#define WriteData(data)		soft_spi_send_byte(1, data)
#elif defined(interface4WSPI)
void WriteCommand(unsigned char command);
void WriteData(unsigned char data);
#elif defined(interfaceI2C)
void WriteCommand(unsigned char command);
void WriteData(unsigned char data);
#else
#error No Interface defined, cannot start
#endif

#endif /* __ATMEGA2561_H__ */