/*
 * cfal12832d.c
 *
 * Created: 2016-05-02 9:29:01 AM
 *  Author: max
 */ 

//Interface definition is in the project settings
//#define interface3WSPI
//#define interface4WSPI
//#define interfaceI2C

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "atmega2561.h"

int main(void)
{
	uint8_t current_screen;
//  uint8_t contrast;

	//Set up the port directions and default states.
	PORTB = 0x00;
	PORTC = 0xCE;
	PORTD = 0xFF;

	DDRB = 0xFF;
	DDRC = 0xFE;
	DDRD = 0x04;		// OLED pins output

	MMC_SD_Init();
	SPI_High();
	OSCCAL = 0x00;		//normal operation maximum the frequency

	// enable VPP
	PORTD |= (1<<3);

	delay(20000L);

	//Get the I2C going
	init_TWI();

	//Fire up the OLED
	Initialize_CFAL12832DB();

	//Show one logo so they know it is working.
	show_128_x_4_bitmap(&Logo_1_I2C);
	show_128_x_4_bitmap(&all_on);

	//Set up interrupt to poll keys
	key_init();
	//Enable interrupts so the keys will get polled in the background
	sei();

	current_screen = 10;
	while(1)
	{
		//See if a key has been pressed
		if(any_keys_waiting())
		{
			uint8_t key_action = getkey();
			if(KEY_PLUS_PRESS == key_action)
			{
				current_screen++;
				if(current_screen == NUMBER_OF_SCREENS)
					current_screen = 0;
			}
			if(KEY_MINUS_PRESS == key_action)
			{
				if(0 != current_screen)
					current_screen--;
				else
					current_screen = (NUMBER_OF_SCREENS - 1);
			}
			//Now put up the bitmap from flash.
			show_128_x_4_bitmap((SCREEN_IMAGE *)pgm_read_word(&screens[current_screen]));
		}
		////Sweep contrast for fun, loop at ~10 Hz
		//_delay_ms(100);
		//WriteCommand(SSD1306B_CONTRAST_PREFIX);
		//WriteCommand(contrast++);
	}

    return 0;
}
